---
title: XRVisibilityState
slug: Web/API/XRVisibilityState
tags:
  - API
  - AR
  - Enum
  - Enumerated Type
  - Focus
  - Reality
  - Reference
  - Type
  - VR
  - Virtual
  - Visibility
  - XR
  - XRVisibilityState
  - augmented
  - blur
  - hidden
---
<p>{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The <code><strong>XRVisibilityState</strong></code> enumerated type defines the string values which are valid for the {{domxref("XRSession")}} interface's {{domxref("XRSession.visibilityState", "visibilityState")}} property, which indicates whether or not an XR session is currently visible to the user, and if it is, whether or not it's currently the primary focus.</span></p>

<h2 id="Values">Values</h2>

<dl>
 <dt><a id="hidden"><code>hidden</code></a></dt>
 <dd>The virtual scene generated by the {{domxref("XRSession")}} is not currently visible to the user, so its {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} callbacks are <em>not</em> being executed until the{{domxref("XRSession.visibilityState", "visibilityState")}} changes. Input controllers are <em>not</em> being handled for the session.</dd>
 <dt><a id="visible"><code>visible</code></a></dt>
 <dd>The virtual scene rendered by the {{domxref("XRSession")}} is currently visible to the user and is the primary focus of the user's attention. To that end, the session's {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} callbacks are being processed at the XR device's native refresh rate and input controllers are being processed as normal.</dd>
 <dt><a id="visible-blurred"><code>visible-blurred</code></a></dt>
 <dd>While the virtual scene rendered by the {{domxref("XRSession")}} may currently be visible to the user, it is not the user's primary focus at the moment; it's also possible the session is not currently visible at all. In order to optimize resource utilization, the {{Glossary("user agent")}} may be handling the session's {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} callbacks at a throttled rate. Input controllers are <em>not</em> being processed for the session.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","enumdef-xrvisibilitystate","XRVisibilityState")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRVisibilityState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("XRSession.onvisibilitychange")}}</li>
 <li>{{DOMxRef("XRSession.visibilitychange_event","visibilitychange")}} event</li>
</ul>
